﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports Syncfusion.UI.Xaml.Diagram

Public Class AutxActivity
    Inherits INPCBase

    Public Property Items As New ObservableCollection(Of AutxComponent)


End Class


Public Class AutxComponent
    Inherits NodeViewModel

    Public Property NodePorts As New ObservableCollection(Of AutxPort)

    Private _ID As String = System.Guid.NewGuid.ToString()
    Public Shadows Property ID As String
        Get
            Return _ID
        End Get
        Set(value As String)
            _ID = value
            MyBase.ID = _ID

        End Set
    End Property


    Public Sub New()
        Me.Constraints = NodeConstraints.Selectable Or NodeConstraints.Draggable
    End Sub

    Public Overridable Function Invoke(doc As Object) As Boolean
        Return True
    End Function

    Public Property Title As String = "Component"

    Public Overrides Function ToString() As String
        Return Title
    End Function

End Class

Public Class AutxPort
    Inherits NodePortViewModel

    Private _ID As String = System.Guid.NewGuid.ToString()
    Public Shadows Property ID As String
        Get
            Return _ID
        End Get
        Set(value As String)
            _ID = value
            MyBase.ID = _ID

        End Set
    End Property


End Class

Public Class AutxConnection
    Inherits INPCBase


End Class


Public Class INPCBase
    Implements INotifyPropertyChanged


    ''' <summary>
    ''' Occurs when any properties are changed on this object.
    ''' </summary>
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged


    ''' <summary>
    ''' A helper method that raises the PropertyChanged event for a property.
    ''' </summary>
    ''' <param name="propertyNames">The names of the properties that changed.</param>
    Public Overridable Sub NotifyChanged(ParamArray propertyNames As String())
        For Each name As String In propertyNames
            OnPropertyChanged(New PropertyChangedEventArgs(name))
        Next
    End Sub

    ''' <summary>
    ''' Raises the PropertyChanged event.
    ''' </summary>
    ''' <param name="e">Event arguments.</param>
    Protected Overridable Sub OnPropertyChanged(e As PropertyChangedEventArgs)

        RaiseEvent PropertyChanged(Me, e)
    End Sub

End Class